#!/bin/bash

# to be run on the mail server at onelab.eu, to add aliases in that domain
# Example:
# new-alias.sh francois2.jan@orange-ftgroup.com
# -> creates one alias
# francois2.jan@onelab.eu -> francois2.jan@orange-ftgroup.com

COMMAND=$(basename $0)

SQL="psql -U mail mail"

function usage () {
  echo "Usage: $command alias1 [ .. aliasn]"
  exit 1
}

function create () {

  target=$1; shift

  namepart=$(echo $target | cut -s -d @ -f 1)
  domainpart=$(echo $target | cut -s -d @ -f 2)
  if [ -z "$namepart" -o -z "$domainpart" ] ; then
    echo "WARNING: $target skipped"
    continue
  fi
  aliasname=${namepart}@onelab.eu
  sqlcommand="insert into alias values ( '${aliasname}', '${target}' )"
  echo "Sending $sqlcommand"
  echo "$sqlcommand" | $SQL

}

function list_aliases () {
  echo 'select * from alias;' | $SQL
}
  

function main () {

  targets="$@" 

  if [[ -z "$targets" ]] ; then
    list_aliases
  else
    for target in "$@" ; do
      create $target
    done
  fi
}

main "$@"
